
/*
 * bs_script_old.h:
 *      header file for bs_script_old.cpp. See remarks there.
 *
 *@@include #include "base\bs_string.h"
 *@@include #include "base\bs_script.h"
 *@@include #include "base\bs_script_old.h"
 */

/*
 *      This file Copyright (C) 1999-2001 Ulrich Mller.
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, in version 2 as it comes in the COPYING
 *      file of this distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */

#ifndef WARPIN_SCRIPT_OLD_HEADER_INCLUDED
    #define WARPIN_SCRIPT_OLD_HEADER_INCLUDED

    /* ******************************************************************
     *
     *  Forward declarations
     *
     ********************************************************************/

    class BSOldScript;

    /* ******************************************************************
     *
     *  Script classes for old-style scripts
     *
     ********************************************************************/

    /*
     *@@ BSOldPckDecl:
     *      implementation for old-style package declarations,
     *      which are created from an old-style script.
     *
     *@@added V0.9.9 (2001-02-28) [umoeller]
     */

    class BSOldPckDecl : public BSPckDeclBase
    {
        public:
            BSOldScript             *_pScript;
                    // the script instance (old style)
                    // this package decl belongs to; always != NULL,
                    // unless this is from a database, where we don't
                    // know the script any more

            BSOldPckDecl(BSOldScript *pScript,
                         BSGroupDeclBase *pGroup_,
                         const char *pszInfo,
                         const char *pszPckAttribs,
                         ULONG ulPckOfs);

        private:
            VOID ParsePckAttribsMain(const char *pszPckAttribs,
                                     ULONG ulAttrOfs);

            LONG ParsePckAttribsRequiresStrings(const char *pszPckAttribs,
                                                ULONG ulAttrOfs);

            LONG ParsePckAttribsConfigSys(const char *pszPckAttribs,
                                          ULONG ulAttrOfs);

            LONG ParsePckAttribsWPSClasses(const char *pszPckAttribs,
                                           ULONG ulAttrOfs);

            LONG ParsePckAttribsWPSObjects(const char *pszPckAttribs,
                                           ULONG ulAttrOfs);

            LONG ParsePckAttribsProfiles(const char *pszPckAttribs,
                                         ULONG ulAttrOfs);

            LONG ParsePckAttribsExecutes(const char *pszPckAttribs,
                                         ULONG ulAttrOfs);

            LONG ParsePckAttribsKillProcesses(const char *pszPckAttribs,
                                              ULONG ulAttrOfs);
    };

    /*
     *@@ BSOldScript:
     *      implementation of BSScriptBase for old-style scripts
     *      (i.e. "compatibility", non-XML scripts).
     *
     *@@added V0.9.9 (2001-02-19) [umoeller]
     */

    class BSOldScript : public BSScriptBase
    {
        public:
            virtual VOID Parse(const BSString &strScript,
                               PFNCONFIRMREXXALLOWED pfnConfirmRexxAllowed);

            VOID ParseError(ULONG ulOfs,
                            const char *pcszFormat, ...);

        private:
            #define GBLREXX_ATTRIBS     0x01
            #define GBLREXX_BLOCK       0x02

            BOOL GetBlock(const char *pcszSearchIn,
                          PULONG pulSearchOfs,
                          PSZ pszTag,
                          ULONG flREXX,
                          BSString *pstrBlock,
                          BSString *pstrAttribs,
                          PULONG pulOfsBeginTag,
                          PULONG pulOfsBeginBlock);

            VOID ParseWARPINTag(const BSString &strScript);

            ULONG ParseHeader(const BSString &strScript,
                              PFNCONFIRMREXXALLOWED pfnConfirmRexxAllowed);

            ULONG ParseVarPrompts(BSString strBlock,
                                  ULONG ulTotalBlockOfs);

            ULONG ParsePackages(BSString strBlock,
                                BSGroupDeclBase *pGroup,
                                ULONG ulTotalBlockOfs);

            ULONG ParsePages(const BSString &strScript);
    };

#endif

