
/*
 *@@sourcefile fe_rexx.h:
 *      header for fe_rexx.c. See remarks there.
 *
 *@@include #define INCL_REXXSAA
 *@@include #include <os2.h>
 *@@include #include <rexxsaa.h>    // if using Toolkit headers; with EMX, this is in os2.h
 */

/*
 *      Copyright (C) 2000 Cornelis Bockemhl.
 *      Copyright (C) 2000 Ulrich Mller.
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, in version 2 as it comes in the COPYING
 *      file of this distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */

#ifndef FEREXX_INCLUDED_
    #define FEREXX_INCLUDED_

    ////////////////////////////////////////////////////////////////////
    // Functions available to REXX scripts
    //
    // Remark: These C style functions are only wrappers for the WarpIN
    // static member functions with the same name: I somehow could not
    // get static class member functions declared as APIENTRY which is
    // necessary for declaring functions for REXX...
    extern "C" {

    ULONG APIENTRY WirexxPutEnv(PCSZ name, ULONG argc, RXSTRING argv[],
                                PCSZ queuename, PRXSTRING retstr);

    ULONG APIENTRY WirexxGetEnv(PCSZ name, ULONG argc, RXSTRING argv[],
                                PCSZ queuename, PRXSTRING retstr);

    ULONG APIENTRY WirexxShowMessage(PCSZ name, ULONG argc, RXSTRING argv[],
                                     PCSZ queuename, PRXSTRING retstr);

    } // end extern "C"

    extern WIREXXFUNCTION   G_aRexxFunctions[];
    extern ULONG            G_cRexxFunctions;

#endif // _WIREXX_INCLUDED_

