/*
 * wipebase.h:
 *      base header file for wipengine.
 *
 *@@include <os2.h>
 */



#ifndef _WIPEBASE_H_
#define _WIPEBASE_H_


/*
 *Message priorities:
 */
#define QUE_MSG_PRIORITY_NORMAL         7
#define QUE_MSG_PRIORITY_HIGHER         4
#define QUE_MSG_PRIORITY_HIGHEST        2
#define QUE_MSG_PRIORITY_LOWER          10
#define QUE_MSG_PRIORITY_LOWEST         14


/*
 * Definition of AID (Archive ID).
 */
typedef HQUEUE AID;


/*
 *@@FNWIPECALLBACK:
 *  typedef for a call-back function.
 */
typedef LONG (FNWIPECALLBACK)(SHORT, // Call-back type
                              LONG, // Type-related information
                              PVOID,  // A pointer to a type-related data
                              PVOID  // A pointer to a user data
                              );
typedef FNWIPECALLBACK *PFNWIPECALLBACK;


/*
 *@@MsgInfo:
 */
struct MsgInfo {
    AID     _aidSender;
    PVOID   _pData;
    HEV     _hevSem;

    MsgInfo() {
        _aidSender = 0;
        _pData = NULL;
        _hevSem = NULLHANDLE;
        }
    ~MsgInfo() {
        // We DO NOT free the memory allocated for _pData in here!
        }
    };


#endif
