
/*
 *@@sourcefile fe_base.cpp:
 *      some base declarations for the front end.
 *
 *@@added V0.9.0 (99-11-07) [umoeller]
 *@@header "frontend\fe_base.h"
 */

/*
 *      This file Copyright (C) 1999-2000 Ulrich Mller.
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation, in version 2 as it comes in the COPYING
 *      file of this distribution.
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 */

#define OS2EMX_PLAIN_CHAR
    // this is needed for "os2emx.h"; if this is defined,
    // emx will define PSZ as _signed_ char, otherwise
    // as unsigned char

#define INCL_DOSERRORS
#include <os2.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "setup.h"              // was missing (99-12-23) [umoeller]

// include's from helpers
#include "helpers\tmsgfile.h"
#include "helpers\xstring.h"

// back-end includes
#include "wiarchive\wiarchive.h"

// base includes (99-11-07) [umoeller]
#include "base\bs_string.h"
#include "base\bs_errors.h"

// front-end includes
#include "frontend\fe_base.h"

#pragma hdrstop

/* ******************************************************************
 *
 *  Exception implementations
 *
 ********************************************************************/

/*
 *@@ FEConstructorExcpt:
 *      constructor for exceptions thrown in
 *      constructors.
 */

FEConstructorExcpt::FEConstructorExcpt(const BSString &strClass,  // in: class name
                                       const char *pszSourceFile,
                                       int iSourceLine,
                                       int iMessage)        // in: msg id
{
    BSString    strMsg2;
    wpiGetMessage(strMsg2,
                  iMessage);

    BSString    strMsg;
    BSString    strSourceFile(pszSourceFile);
    BSString    strSourceLine;
    strSourceLine._printf("%d", iSourceLine);
    const char  *apsz[] = {    strClass.c_str(),
                               strSourceFile.c_str(),
                               strSourceLine.c_str(),
                               strMsg2.c_str()
                           };
    wpiGetMessage(strMsg,
                  166,      // error in constructor
                  (PCHAR*)apsz, 4);
    _strDescription = strMsg;
}

/*
 *@@ FEFatalErrorExcpt:
 *      constructor 1 for generic fatal error messages.
 */

FEFatalErrorExcpt::FEFatalErrorExcpt(const BSString &strMessage)
{
    _strDescription = strMessage;
}

/*
 *@@ FEFatalErrorExcpt:
 *      constructor 2 for generic fatal error messages.
 */

FEFatalErrorExcpt::FEFatalErrorExcpt(int iMessage,     // in: TMF msg id
                                     char** apszTable,
                                     int iCount)
{
    BSString    strMsg2;
    wpiGetMessage(strMsg2,
                  iMessage,
                  apszTable, iCount);
    _strDescription = strMsg2;
}

/*
 *@@ FEEnvironmentExcept:
 *      constructor for environment errors.
 */

FEEnvironmentExcept::FEEnvironmentExcept(const BSString &strCommand,
                                         const BSString &strValue)
{
    BSString    strMsg2;
    const char  *apsz[2] = { strCommand.c_str(), strValue.c_str() };
    wpiGetMessage(strMsg2,
                  167,
                  (PCHAR*)apsz, 2);
    _strDescription = strMsg2;
}


