
// ---------------------------------------------------------------------------
//  Includes
// ---------------------------------------------------------------------------

#include <stdio.h>
#include <iostream.h>

#include <parsers/SAXParser.hpp>
#include <framework/LocalFileInputSource.hpp>
#include <dom/DOM.hpp>

#include <util/PlatformUtils.hpp>
#include <util/TransService.hpp>

int main(int argC, char* argV[])
{
    // Initialize the XML4C system
    try
    {
        XMLPlatformUtils::Initialize();

        if (argC != 2)
        {
            printf("Usage: xmltest <file.xml>\n");
        }
        else
        {
            SAXParser::ValSchemes    valScheme = SAXParser::Val_Auto;
            bool                     doNamespaces = false;

            XMLCh*                   xmlchFileName = XMLString::transcode(argV[1]);

            LocalFileInputSource     src(xmlchFileName);

            //
            //  Create a SAX parser object. Then, according to what we were told on
            //  the command line, set it to validate or not.
            //
            SAXParser parser;
            parser.parse(src);

        }
    }
    catch(...)
    {
        printf("Error.");
    }

    XMLPlatformUtils::Terminate();
}


